﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Drawing;
using System.Collections;
using System.Diagnostics;

namespace MyNote001
{

    public class DotDrawCycle
    {
        bool[,] dotDrawCycle;
        Size sizeDotDrawCycle;
        Point pointDotDrawCycleNow;

        public enum DotDrawCycleMode { LAYER, CYCLE, CYCLE2, STAMP };
        DotDrawCycleMode dotdrawcyclemode;

        public DotDrawCycle()
        {
            bool[,] dot = new bool[1, 1];
            dot[0, 0] = true;
            SetDotDrawCycle(dot, 1, 1);
            dotdrawcyclemode = DotDrawCycleMode.LAYER;

            /*
            bool[,] dot2 = new bool[1, 8] { 
            {true,true,true,false,false,false,true,true},
            };

            SetDotDrawCycle(dot2, 1, 8);
             * */


            /*
            bool[,] dot3 = new bool[8, 8] { 
            {true,true,true,false,false,false,true,true},
            {true,true,true,false,false,false,true,true},
            {true,false,false,false,false,false,false,false},
            {true,false,false,false,false,false,false,false},
            {true,false,false,false,false,false,false,false},
            {true,false,false,false,false,false,false,false},
            {true,true,true,false,false,false,true,true},
            {true,true,true,false,false,false,true,true}
            };

            SetDotDrawCycle(dot3, 8, 8);
             * */
        }

        public void SetDotDrawCycle(bool[,] dots, int width, int height)
        {
            if (width < 1 || height < 1 || dots.Length < width * height)
            {
               throw new Exception("SetDotDrawCycle ");
            }
            else
            {
                dotDrawCycle = dots;
                sizeDotDrawCycle.Width = width;
                sizeDotDrawCycle.Height = height;
            }

            pointDotDrawCycleNow = new Point(0, 0);     
        }

        public Size getSizeDotDrawCycle()
        {
            return this.sizeDotDrawCycle;
        }


        public void SetDotDrawCycleMode(DotDrawCycleMode ddcm)
        {
            this.dotdrawcyclemode = ddcm;
        }

        public DotDrawCycleMode GetDotDrawCycleMode()
        {
            return this.dotdrawcyclemode;
        }

        // LayerのStampDDC()が利用する。
        public bool getDrawOrNotDotDrawCycle(int x, int y)
        {
            if (x < 0 || x > this.sizeDotDrawCycle.Width - 1 || y < 0 || y > this.sizeDotDrawCycle.Height - 1)
            {
                throw new Exception("getDrawOrNotDrawCycle");
            }

            return this.dotDrawCycle[x, y];
        }

        public bool getNextDotDrawOrNotByDotDrawCycle(int xx, int yy)
        {
            bool result = dotDrawCycle[xx % this.sizeDotDrawCycle.Width, yy % this.sizeDotDrawCycle.Height];

            if (dotdrawcyclemode == DotDrawCycleMode.CYCLE || dotdrawcyclemode == DotDrawCycleMode.CYCLE2)
            {
                result = dotDrawCycle[pointDotDrawCycleNow.X, pointDotDrawCycleNow.Y];

                int x = pointDotDrawCycleNow.X + 1;
                if (x > sizeDotDrawCycle.Width - 1)
                {
                    x = 0;
                    pointDotDrawCycleNow.Y += 1;
                }
                int y = pointDotDrawCycleNow.Y;
                if (y > sizeDotDrawCycle.Height - 1)
                {
                    y = 0;
                }
                pointDotDrawCycleNow.X = x;
                pointDotDrawCycleNow.Y = y;

                
            }
            else if (dotdrawcyclemode == DotDrawCycleMode.LAYER)
            {
            }
            else if (dotdrawcyclemode == DotDrawCycleMode.STAMP)
            {
                result = true;
            }
            return result;
        }

        public void resetpointDotDrawCycleNow()
        {
            pointDotDrawCycleNow.X = pointDotDrawCycleNow.Y = 0;
        }
    }

    /// <summary>
    /// ///////////////////////////////////////////////////
    /// </summary>

    class Layer
    {
        //uint[,] dot;
        int[,] alpha;
        int[,] red;
        int[,] green;
        int[,] blue;
        int Width;
        int Height;
        // antiAliasing
        int[,] aa_alpha;
        int[,] aa_red;
        int[,] aa_green;
        int[,] aa_blue;
        
        // レイヤーごとに記憶する。
        // 使用するクラスが初期化する。
        public enum DotDrawMode { OVERWRITE, SIMPLEMIX };
        DotDrawMode dotdrawmode;
        int[] transparent;

        // 描画命令の度に、どれを使うか教えてもらう。FillRectangleをのぞく。STAMPのぞく。
        public enum DrawLinePenKind { FIX_SQUARE_FILL, UNFIX_RECTANGLE_FILL, CIRCLE_FILL,
            FUNNY_BUG_UNFIX_RECTANGLE_FILL, 
            FUNNY_BUG2_UNFIX_RECTANGLE_FILL, FUNNY_BUG2B_UNFIX_RECTANGLE_FILL,
            CIRCLE_RANDOM_DOT_CONC,
            CIRCLE_RANDOM_DOT_MID,
            CIRCLE_RANDOM_DOT_SPARSE,
            USER_PEN_KIND_METHOD1,
            USER_PEN_KIND_METHOD2
        };


        int seedForRandom = Environment.TickCount;
        int seedStep = 109; // 適当に選んだ素数。271。
        Random random;

        public const double DDMSM_High = 0.1;
        public const double DDMSM_Middle = 0.05;
        public const double DDMSM_Low = 0.02;
        public const double DDMSM_None = 0.0;
        double DDMSM_Rate = DDMSM_Middle;


        const System.Drawing.Imaging.PixelFormat FORMAT = System.Drawing.Imaging.PixelFormat.Format32bppArgb;

        bool[,] dotIsWritten;

        DotDrawCycle dotDrawCycle;

        public bool antiAliasing = false;
        public enum AntiAliasingType {AAT1, AAT2 };
        AntiAliasingType aat;

        public Layer(int width, int height, int a, int[] colors, int[] transparent)
        {
            //this.dot = new uint[width,height];
            this.alpha = new int[width, height];
            this.red = new int[width, height];
            this.green = new int[width, height];
            this.blue = new int[width, height];
            this.aa_alpha = new int[width, height];
            this.aa_red = new int[width, height];
            this.aa_green = new int[width, height];
            this.aa_blue = new int[width, height];
            this.Width = width;
            this.Height = height;
            this.initdots(a,colors);
            this.transparent = transparent;
            this.dotIsWritten = new bool[width, height];
            random = new Random(seedForRandom + seedStep);
            dotDrawCycle = new DotDrawCycle();
        }

        public void SetLayerDotDrawCycle(DotDrawCycle ddc)
        {
            this.dotDrawCycle = ddc;
        }

        public void SetDDMSM_Rate(double rate)
        {
            if (rate < 0) return;
            if (rate > 1.0) return;
            DDMSM_Rate = rate;
        }

        public double GetDDMSM_Rate()
        {
            return DDMSM_Rate;
        }

        public void initdots(int a, int[] colors)
        {
            for (int x = 0; x < Width; x++)
            {
                for (int y = 0; y < Height; y++)
                {
                    this.SetDot(x, y, a, colors);
                }
            }
        }

        //public uint GetDot(int x, int y)
        //{
        //    return this.dot[x,y];
        //}

        public void SetDot(int x, int y, int a, int[] colors)
        {
            if (x < 0) x = 0;
            if (x > Width-1) x = Width-1;
            if (y < 0) y = 0;
            if (y > Height-1) y = Height-1;
            //this.dot[x,y] = value;
            this.alpha[x, y] = a;
            this.red[x, y] = colors[0];
            this.green[x, y] = colors[1];
            this.blue[x, y] = colors[2];
        }

        private void SetDot(int x, int y, int argb)
        {
            int a = (int)((uint)argb / 0x1000000);
            int[] colors = { (argb & 0x00ff0000) / 0x10000, (argb & 0x0000ff00) / 0x100, argb & 0x000000ff };
            SetDot(x, y, a, colors);
        }

        public int GetDotAlpha(int x, int y)
        {
            if (x < 0 || x > Width - 1 || y < 0 || y > Height - 1)
                throw new Exception("Layer GetDotAlpha()");
            return this.alpha[x, y];
        }

        public int GetDotRed(int x, int y)
        {
            if (x < 0 || x > Width - 1 || y < 0 || y > Height - 1)
                throw new Exception("Layer GetDotRed()");
            return this.red[x, y];
        }

        public int GetDotGreen(int x, int y)
        {
            if (x < 0 || x > Width - 1 || y < 0 || y > Height - 1)
                throw new Exception("Layer GetDotGreen()");
            return this.green[x, y];
        }

        public int GetDotBlue(int x, int y)
        {
            if (x < 0 || x > Width - 1 || y < 0 || y > Height - 1)
                throw new Exception("Layer GetDotBlue()");
            return this.blue[x, y];
        }

        public int[] GetDotColors(int x, int y)
        {
            // 書き換えられてもかまわない配列を返す。
            int[] colors = new int[3];
            colors[0] = GetDotRed(x, y);
            colors[1] = GetDotGreen(x, y);
            colors[2] = GetDotBlue(x, y);
            return colors;
        }

        public int[] GetDotARGB(int x, int y)
        {
            // 書き換えられてもかまわない配列を返す。
            int[] argb = new int[4];
            try
            {
                argb[0] = GetDotAlpha(x, y);
                argb[1] = GetDotRed(x, y);
                argb[2] = GetDotGreen(x, y);
                argb[3] = GetDotBlue(x, y);
            }
            catch (Exception e)
            {
                throw new Exception("Layer GetDotARGB " + e.ToString());
            }
            return argb;
        }

        public void SetFromBitmap(Bitmap bmp)
        {
            if (bmp.Width != this.Width)
            {
                throw new Exception("not same width");
            }
            if (bmp.Height != this.Height)
            {
                throw new Exception("not same height");
            }

            for (int x = 0; x < Width; x++)
            {
                for (int y = 0; y < Height; y++)
                {
                    int argb = bmp.GetPixel(x,y).ToArgb();
                    SetDot(x, y, argb);
                }
            }
        }

        public Bitmap GetBitmap()
        {
            Bitmap bmp = new Bitmap(Width, Height,FORMAT);
            for (int x = 0; x < Width; x++)
            {
                for (int y = 0; y < Height; y++)
                {
                    bmp.SetPixel(x, y, Color.FromArgb(GetDotAlpha(x, y), GetDotRed(x, y), GetDotGreen(x, y), GetDotBlue(x, y)));
                }
            }
            return bmp;
        }

        public void setDotDrawMode(DotDrawMode ddm)
        {
            this.dotdrawmode = ddm;
        }

        public DotDrawMode getDotDrawMode()
        {
            return dotdrawmode;
        }

        public bool IsDotTransparent(int x, int y)
        {
            bool result = false;
            if (GetDotRed(x, y) == transparent[0] && GetDotGreen(x, y) == transparent[1] && GetDotBlue(x, y) == transparent[2])
            {
                result = true;
            }
            return result;

        }

        // ////////////////////////////////////////////////////////////////////////////////

        private void dotOverWrite(int x, int y, int alpha, int[] colors)
        {
            if (x < 0 || x > Width - 1 || y < 0 || y > Height - 1)
                return;

            if (dotDrawCycle.getNextDotDrawOrNotByDotDrawCycle(x,y))
            {
                SetDot(x, y, alpha, colors);
            }
        }

        private void dotSimpleMix(int x, int y, int alpha, int[] colors)
        {
            if (x < 0 || x > Width - 1 || y < 0 || y > Height - 1)
                return;

            if (dotDrawCycle.getNextDotDrawOrNotByDotDrawCycle(x,y))
            {
                int[] result = new int[4];
                result[0] = alpha;
                result[1] = colors[0];
                result[2] = colors[1];
                result[3] = colors[2];
                result = getMixedArgbFrom2Argb(result, GetDotARGB(x, y));
                int[] tmpcolors = { result[1], result[2], result[3] };
                SetDot(x, y, result[0], tmpcolors);
            }
        }

        // argb2がもとからある色
        private int[] getMixedArgbFrom2Argb(int[] argb1, int[] argb2)
        {
            int[] resultArgb = new int[4];
            int[] argb1colors = { argb1[1], argb1[2], argb1[3] };
            int[] argb2colors = { argb2[1], argb2[2], argb2[3] };
            if (IsColorsTransparent(argb2colors))
            {
                // もとからあるのが透明色なら、新しい色に。
                resultArgb[0] = argb1[0];
                resultArgb[1] = argb1[1];
                resultArgb[2] = argb1[2];
                resultArgb[3] = argb1[3];
            }
            else if (IsColorsTransparent(argb1colors))
            {
                // あたらしくくるのが透明色なら、透明色に。
                resultArgb[0] = argb1[0];
                resultArgb[1] = argb1[1];
                resultArgb[2] = argb1[2];
                resultArgb[3] = argb1[3];
            }
            else
            {
                // alpha
                resultArgb[0] = ( argb2[0] + (int)((argb1[0] - argb2[0]) * DDMSM_Rate)); // 少しずつ近づける。
                if (resultArgb[0] < 0) resultArgb[0] = 0;
                if (resultArgb[0] > 255) resultArgb[0] = 255;
                // rgb
                double[] cmyk1 = RGBtoCMYK(argb1[1], argb1[2], argb1[3]);
                double[] cmyk2 = RGBtoCMYK(argb2[1], argb2[2], argb2[3]);
                double[] mixedcmyk = MixCMYK(cmyk1, cmyk2);
                int[] tmpcolors = CMYKtoRGB(mixedcmyk);
                resultArgb[1] = tmpcolors[0];
                resultArgb[2] = tmpcolors[1];
                resultArgb[3] = tmpcolors[2];
            }
            return resultArgb;
        }

        private double[] RGBtoCMYK(int red, int green, int blue)
        {
            double dred = red;
            double dgreen = green;
            double dblue = blue;
            double[] cmyk = new double[4];
            double black = Math.Min(1 - dred / 255, Math.Min(1 - dgreen / 255, 1 - dblue / 255));
            cmyk[0] = (1 - (dred / 255) - black) / (1 - black);
            cmyk[1] = (1 - (dgreen / 255) - black) / (1 - black);
            cmyk[2] = (1 - (dblue / 255) - black) / (1 - black);
            cmyk[3] = black;

            return cmyk;
        }

        // cmyk2がもとからある色。
        private double[] MixCMYK(double[] cmyk1, double[] cmyk2)
        {
            double[] cmyk = new double[4];

            for (int i = 0; i < 4; i++)
            {
                cmyk[i] = cmyk2[i] + (cmyk1[i] - cmyk2[i]) * DDMSM_Rate; // 少しずつ近づける。
                if (cmyk[i] > 1) cmyk[i] = 1.0;
                if (cmyk[i] < 0) cmyk[i] = 0.0;
            }

            return cmyk;
        }

        private int[] CMYKtoRGB(double[] cmyk)
        {
            int[] colors = new int[3];

            double cyan = cmyk[0];
            double magenta = cmyk[1];
            double yellow = cmyk[2];
            double black = cmyk[3];
            int red = (int)((1 - Math.Min(1, cyan * (1 - black) + black)) * 255);
            int green = (int)((1 - Math.Min(1, magenta * (1 - black) + black)) * 255);
            int blue = (int)((1 - Math.Min(1, yellow * (1 - black) + black)) * 255);
            if (red < 0) red = 0;
            if (green < 0) green = 0;
            if (blue < 0) blue = 0;
            if (red > 255) red = 255;
            if (green > 255) green = 255;
            if (blue > 255) blue = 255;
            colors[0] = red; colors[1] = green; colors[2] = blue;
            return colors;
        }

        private bool IsColorsTransparent(int[] colors)
        {
            bool result = false;
            if (transparent[0] == colors[0] && transparent[1] == colors[1] && transparent[2] == colors[2])
            {
                result = true;
            }
            return result;
        }

        private void setDotIsWrittenFalse(int x,int y)
        {
            if (x < 0 || x > Width - 1 || y < 0 || y > Height - 1)
                return;

            dotIsWritten[x, y] = false;

        }

        private void setDotIsWrittenTrue(int x, int y)
        {
            if (x < 0 || x > Width - 1 || y < 0 || y > Height - 1)
                return;

            dotIsWritten[x, y] = true;

        }

        private bool DotIsWritten(int x, int y)
        {
            if (x < 0 || x > Width - 1 || y < 0 || y > Height - 1)
                return false;
            return dotIsWritten[x, y];
        }



        // ///////////////////////////////////////////////////////
        // ///////////////////////////////////////////////////////////
        
        // Layerに対する描画はこれがよばれる。FillRectangle以外。ForUserPenKind除く。
        public Rectangle DrawLine(int a, int[] colors, Point startP, Point endP, int width, bool IsPENMODE_LINE, DrawLinePenKind dlpk)
        {
            if (dotDrawCycle.GetDotDrawCycleMode() == DotDrawCycle.DotDrawCycleMode.CYCLE2)
            {
                dotDrawCycle.resetpointDotDrawCycleNow();
            }

            Rectangle rect;
            switch (dlpk)
            {
                case DrawLinePenKind.FIX_SQUARE_FILL:
                    rect = DrawLine_FIX_SQUARE_FILL(a, colors, startP, endP, width, IsPENMODE_LINE);
                    break;
                case DrawLinePenKind.UNFIX_RECTANGLE_FILL:
                    rect = DrawLine_UNFIX_RECTANGLE_FILL(a, colors, startP, endP, width, IsPENMODE_LINE);
                    break;
                case DrawLinePenKind.CIRCLE_FILL:
                    rect = DrawLine_CIRCLE_FILL(a, colors, startP, endP, width, IsPENMODE_LINE);
                    break;
                case DrawLinePenKind.FUNNY_BUG_UNFIX_RECTANGLE_FILL:
                    rect = DrawLine_DrawLine_FUNNY_BUG_UNFIX_RECTANGLE_FILL(a, colors, startP, endP, width, IsPENMODE_LINE);
                    break;
                case DrawLinePenKind.FUNNY_BUG2_UNFIX_RECTANGLE_FILL:
                    rect = DrawLine_DrawLine_FUNNY_BUG2_UNFIX_RECTANGLE_FILL(a, colors, startP, endP, width, IsPENMODE_LINE, dlpk);
                    break;
                case DrawLinePenKind.FUNNY_BUG2B_UNFIX_RECTANGLE_FILL:
                    rect = DrawLine_DrawLine_FUNNY_BUG2_UNFIX_RECTANGLE_FILL(a, colors, startP, endP, width, IsPENMODE_LINE, dlpk);
                    break;
                case DrawLinePenKind.CIRCLE_RANDOM_DOT_CONC:
                    rect = DrawLine_DrawLine_CIRCLE_RANDOM_DOT(a, colors, startP, endP, width, IsPENMODE_LINE, dlpk);
                    break;
                case DrawLinePenKind.CIRCLE_RANDOM_DOT_MID:
                    rect = DrawLine_DrawLine_CIRCLE_RANDOM_DOT(a, colors, startP, endP, width, IsPENMODE_LINE, dlpk);
                    break;
                case DrawLinePenKind.CIRCLE_RANDOM_DOT_SPARSE:
                    rect = DrawLine_DrawLine_CIRCLE_RANDOM_DOT(a, colors, startP, endP, width, IsPENMODE_LINE, dlpk);
                    break;
                default:
                    rect = new Rectangle(0,0,0,0);
                    break;
            }
            if (this.antiAliasing)
            {
                AntiAliasing(rect);
            }
            return rect;
        }




        // //////////////////////////////////////////////////////////////////////

        // Funny_bug
        private Rectangle DrawLine_DrawLine_FUNNY_BUG_UNFIX_RECTANGLE_FILL(int a, int[] colors, Point startP, Point endP, int width, bool IsPENMODE_LINE)
        {
            // 忘れるな
             // switch (dotdrawmode)

            double dx = (double)(endP.X - startP.X);
            double dy = (double)(endP.Y - startP.Y);
            // double d = Math.Sqrt(dx * dx + dy * dy);

            if (dx == 0 && dy == 0)
            {
                Rectangle rect = new Rectangle(0,0,1,1);
                return rect;
            }

            Point[] startmagicpoints = getMagicPointsFunny(startP, startP, endP, width);
            Point[] endmagicpoints = getMagicPointsFunny(endP, startP, endP, width);

            int smallX = Math.Min(startmagicpoints[0].X, Math.Min(startmagicpoints[1].X, Math.Min(endmagicpoints[0].X, endmagicpoints[1].X)));
            int largeX = Math.Max(startmagicpoints[0].X, Math.Max(startmagicpoints[1].X, Math.Max(endmagicpoints[0].X, endmagicpoints[1].X)));
            int smallY = Math.Min(startmagicpoints[0].Y, Math.Min(startmagicpoints[1].Y, Math.Min(endmagicpoints[0].Y, endmagicpoints[1].Y)));
            int largeY = Math.Max(startmagicpoints[0].Y, Math.Max(startmagicpoints[1].Y, Math.Max(endmagicpoints[0].Y, endmagicpoints[1].Y)));

            // 使いそうなところをfalseに
            for (int x = smallX; x <= largeX; x++)
            {
                for (int y = smallY; y <= largeY; y++)
                {
                    setDotIsWrittenFalse(x, y);
                }
            }

            for (int x = smallX; x <= largeX; x++)
            {
                for (int y = smallY; y <= largeY; y++)
                {
                    if (true)
                    {
                        switch (dotdrawmode)
                        {
                            case DotDrawMode.OVERWRITE:
                                if (!DotIsWritten(x,y))
                                {
                                    dotOverWrite(x,y, a, colors);
                                    setDotIsWrittenTrue(x,y);
                                }
                                break;
                            case DotDrawMode.SIMPLEMIX:
                                if (!DotIsWritten(x,y))
                                {
                                    dotSimpleMix(x,y, a, colors);
                                    setDotIsWrittenTrue(x,y);
                                }
                                break;
                            default: break;
                        }
                    }
                }
            }


            Rectangle rect2 = new Rectangle(smallX, smallY, largeX - smallX + 1, largeY - smallY + 1);
            return rect2;
        }

        // Funny_bug
        private Point[] getMagicPointsFunny(Point p, Point startP, Point endP, int width)
        {
            Point[] points = new Point[2];

            if (startP.X == endP.X)
            {
                points[0].X = p.X - width / 2;
                points[1].X = p.X + width / 2;
                points[0].Y = p.Y;
                points[1].Y = p.Y;
            }
            else if (startP.Y == endP.Y)
            {
                points[0].X = p.X;
                points[1].X = p.X;
                points[0].Y = p.Y - width / 2;
                points[1].Y = p.Y + width / 2;
            }
            else
            {
                double dx = (double)(endP.X - startP.X);
                double dy = (double)(endP.Y - startP.Y);
                double d = Math.Sqrt(dx * dx + dy * dy);
                points[0].X = p.X - (int)((dy / d) * width / 2);
                points[0].Y = p.Y - (int)((dx / d) * width / 2);
                points[1].X = p.X - (int)((dy / d) * width / 2);
                points[1].Y = p.Y - (int)((dx / d) * width / 2);
            }
            return points;
        }



        // //////////////////////////////////////////////////////////////////////////

        //Funny_bug2
        private Rectangle DrawLine_DrawLine_FUNNY_BUG2_UNFIX_RECTANGLE_FILL(int a, int[] colors, Point startP, Point endP, int width, bool IsPENMODE_LINE, DrawLinePenKind dlpk)
        {
            // 忘れるな
             // switch (dotdrawmode)

            double dx = (double)(endP.X - startP.X);
            double dy = (double)(endP.Y - startP.Y);
            // double d = Math.Sqrt(dx * dx + dy * dy);

            if (dx == 0 && dy == 0)
            {
                Rectangle rect = new Rectangle(0,0,0,0);
                return rect;
            }

            PointF[] startmagicpoints = getMagicPointsFunnyBug2(startP, startP, endP, width);
            PointF[] endmagicpoints = getMagicPointsFunnyBug2(endP, startP, endP, width);

            int smallX = (int)Math.Min(startmagicpoints[0].X, Math.Min(startmagicpoints[1].X, Math.Min(endmagicpoints[0].X, endmagicpoints[1].X)))-1;
            int largeX = (int)Math.Max(startmagicpoints[0].X, Math.Max(startmagicpoints[1].X, Math.Max(endmagicpoints[0].X, endmagicpoints[1].X)))+1 ;
            int smallY = (int)Math.Min(startmagicpoints[0].Y, Math.Min(startmagicpoints[1].Y, Math.Min(endmagicpoints[0].Y, endmagicpoints[1].Y)))-1;
            int largeY = (int)Math.Max(startmagicpoints[0].Y, Math.Max(startmagicpoints[1].Y, Math.Max(endmagicpoints[0].Y, endmagicpoints[1].Y)))+1;

            // 使いそうなところをfalseに
            for (int x = smallX; x <= largeX; x++)
            {
                for (int y = smallY; y <= largeY; y++)
                {
                    setDotIsWrittenFalse(x, y);
                }
            }

            for (int x = smallX; x <= largeX; x++)
            {
                for (int y = smallY; y <= largeY; y++)
                {
                    if (DotIsWritten(x,y))
                        continue;
                    if (isIncludeFunnyBug2(x, y, startmagicpoints, endmagicpoints, dlpk))
                    {
                        switch (dotdrawmode)
                        {
                            case DotDrawMode.OVERWRITE:
                                    dotOverWrite(x,y, a, colors);
                                    setDotIsWrittenTrue(x,y);
                                break;
                            case DotDrawMode.SIMPLEMIX:
                                if (!DotIsWritten(x,y))
                                    dotSimpleMix(x,y, a, colors);
                                    setDotIsWrittenTrue(x,y);
                                break;
                            default: break;
                        }
                    }
                }
            }


            Rectangle rect2 = new Rectangle(smallX, smallY, largeX - smallX, largeY - smallY);
            return rect2;
        }

        // funny_bug2
        private PointF[] getMagicPointsFunnyBug2(Point p, Point startP, Point endP, int width)
        {
            PointF[] points = new PointF[2];

            if (startP.X == endP.X)
            {
                points[0].X = p.X - (float)width / 2;
                points[1].X = p.X + (float)width / 2;
                points[0].Y = p.Y;
                points[1].Y = p.Y;
            }
            else if (startP.Y == endP.Y)
            {
                points[0].X = p.X;
                points[1].X = p.X;
                points[0].Y = p.Y - (float)width / 2;
                points[1].Y = p.Y + (float)width / 2;
            }
            else
            {
                double dx = (double)(endP.X - startP.X);
                double dy = (double)(endP.Y - startP.Y);
                double d = Math.Sqrt(dx * dx + dy * dy);
                points[0].X = (float)(p.X - ((dy / d) * width / 2));
                points[0].Y = (float)(p.Y - ((dx / d) * width / 2));
                points[1].X = (float)(p.X + ((dy / d) * width / 2));
                points[1].Y = (float)(p.Y + ((dx / d) * width / 2));
            }
            return points;
        }

        // funny_bug2
        private bool isIncludeFunnyBug2(int x, int y, PointF[] startpoints, PointF[] endpoints, DrawLinePenKind dlpk)
        {
            bool result = false;

            switch (dlpk)
            {
                case DrawLinePenKind.FUNNY_BUG2_UNFIX_RECTANGLE_FILL:
                    if (isIncludeFunnyBug2(x, y, startpoints[0], startpoints[1], endpoints[0]))
                    {
                        result = true;
                    }
                    break;
                case DrawLinePenKind.FUNNY_BUG2B_UNFIX_RECTANGLE_FILL:
                    if (isIncludeFunnyBug2(x, y, startpoints[0], startpoints[1], endpoints[1]))
                    {
                        result = true;
                    }
                    break;

            }

            return result;
        }

        // funny_bug2
        private bool isIncludeFunnyBug2(int x, int y, PointF o, PointF p1, PointF p2)
        {
            bool result = false;

            PointF vec = new PointF(x - o.X, y - o.Y);
            PointF vecP1 = new PointF(p1.X - o.X, p1.Y - o.Y);
            PointF vecP2 = new PointF(p2.X - o.X, p2.Y - o.Y);
            double L0 = Math.Sqrt((double)vec.X * (double)vec.X + (double)vec.Y * (double)vec.Y);
            double L1 = Math.Sqrt((double)vecP1.X * (double)vecP1.X + (double)vecP1.Y * (double)vecP1.Y);
            double L2 = Math.Sqrt((double)vecP2.X * (double)vecP2.X + (double)vecP2.Y * (double)vecP2.Y);

            if (L1 == 0.0 && L2 == 0.0)
            {
                result = false;
            }
            else if (L1 == 0.0)
            {
                result = false;
            }
            else if (L2 == 0.0)
            {
                result = false;
            }
            else
            {
                double l1 = Math.Abs((double)crosPs(vec, vecP1) / L1);
                double l2 = Math.Abs((double)crosPs(vec, vecP2) / L2);
                if (l1 <= L2 && l2 <= L1)
                {
                    if (crosPs(vecP1, vecP2) > 0 && crosPs(vecP1, vec) > 0 && crosPs(vec, vecP2) > 0)
                    {
                        result = true;
                    }
                    else if (crosPs(vecP1, vecP2) < 0 && crosPs(vecP1, vec) < 0 && crosPs(vec, vecP2) < 0)
                    {
                        result = true;
                    }

                }
            }

            return result;
        }




        // //////////////////////////////////////////////////////////////////


        private float crosPs(PointF p1, PointF p2)
        {
            return p1.X * p2.Y - p2.X * p1.Y;
        }

        // /////////////////////////////////////////////////////////////////



        // ////////////////////////////////////////////////////////////////



        // 辺width * (width / ?)の長方形のwidthの辺の中心をstartPに置き、その辺がendPにぶつかるまで動かしていくような描画。
        // 長方形の辺はstartPとendPを結んだ線に平行または直行。
        //        
        // 直径widthの円の中心をstartPに置き、endPまで中心を動かしていくような描画。
        //
        private Rectangle DrawLine_UNFIX_RECTANGLE_FILL_AND_CIRCLE_FILL(int a, int[] colors, Point startP, Point endP, int width, bool IsPENMODE_LINE, DrawLinePenKind dlpk)
        {
            // 忘れるな
            // switch (dotdrawmode)

            double dx = (double)(endP.X - startP.X);
            double dy = (double)(endP.Y - startP.Y);
            double d = Math.Sqrt(dx * dx + dy * dy);

            if (dx == 0 && dy == 0)
            {
                Rectangle rect = new Rectangle(0, 0, 0, 0);
                return rect;
            }

            PointF[] startmagicpoints = getMagicPoints(startP, startP, endP, width);
            PointF endPF = new PointF(endP.X, endP.Y);

            if (dlpk == DrawLinePenKind.UNFIX_RECTANGLE_FILL)
            {
                //endPF.X += (float)((double)width * dx / d / 5.0);
                //endPF.Y += (float)((double)width * dy / d / 5.0);
            }
            
            PointF[] endmagicpoints = getMagicPoints(endPF, startP, endP, width);

            int smallX = (int)Math.Min(startmagicpoints[0].X, Math.Min(startmagicpoints[1].X, Math.Min(endmagicpoints[0].X, endmagicpoints[1].X))) - width / 2;
            int largeX = (int)Math.Max(startmagicpoints[0].X, Math.Max(startmagicpoints[1].X, Math.Max(endmagicpoints[0].X, endmagicpoints[1].X))) + width / 2;
            int smallY = (int)Math.Min(startmagicpoints[0].Y, Math.Min(startmagicpoints[1].Y, Math.Min(endmagicpoints[0].Y, endmagicpoints[1].Y))) - width / 2;
            int largeY = (int)Math.Max(startmagicpoints[0].Y, Math.Max(startmagicpoints[1].Y, Math.Max(endmagicpoints[0].Y, endmagicpoints[1].Y))) + width / 2;

            // 使いそうなところをfalseに
            for (int x = smallX; x <= largeX; x++)
            {
                for (int y = smallY; y <= largeY; y++)
                {
                    setDotIsWrittenFalse(x, y);
                }
            }

            for (int x = smallX; x <= largeX; x++)
            {
                for (int y = smallY; y <= largeY; y++)
                {
                    if (DotIsWritten(x, y))
                        continue;

                    bool include = false;
                    switch (dlpk)
                    {
                        case DrawLinePenKind.UNFIX_RECTANGLE_FILL:
                            include = isInclude(x, y, startmagicpoints, endmagicpoints);
                            break;
                        case DrawLinePenKind.CIRCLE_FILL:
                            include = isInclude(x, y, startmagicpoints, endmagicpoints) ||
                                 (x - startmagicpoints[0].X) * (x - startmagicpoints[0].X) + (y - startmagicpoints[0].Y) * (y - startmagicpoints[0].Y) + (x - startmagicpoints[1].X) * (x - startmagicpoints[1].X) + (y - startmagicpoints[1].Y) * (y - startmagicpoints[1].Y) <= width * width ||
                                 (x - endmagicpoints[0].X) * (x - endmagicpoints[0].X) + (y - endmagicpoints[0].Y) * (y - endmagicpoints[0].Y) + (x - endmagicpoints[1].X) * (x - endmagicpoints[1].X) + (y - endmagicpoints[1].Y) * (y - endmagicpoints[1].Y) <= width * width;
                            break;
                        default: break;
                    }


                    if (include)
                    {
                        switch (dotdrawmode)
                        {
                            case DotDrawMode.OVERWRITE:
                                dotOverWrite(x, y, a, colors);
                                setDotIsWrittenTrue(x, y);
                                break;
                            case DotDrawMode.SIMPLEMIX:
                                if (!DotIsWritten(x, y))
                                    dotSimpleMix(x, y, a, colors);
                                setDotIsWrittenTrue(x, y);
                                break;
                            default: break;
                        }
                    }  
                }  
            }

            Rectangle rect2 = new Rectangle(smallX, smallY, largeX - smallX + 1, largeY - smallY + 1);
            return rect2;
        }

        private PointF[] getMagicPoints(PointF p, PointF startP, PointF endP, int width)
        {
            PointF[] points = new PointF[2];

            double dx = (double)(endP.X - startP.X);
            double dy = (double)(endP.Y - startP.Y);
            double d = Math.Sqrt(dx * dx + dy * dy);

            if (startP.X == endP.X)
            {
                points[0].X = p.X - (float)width / 2;
                points[1].X = p.X + (float)width / 2;
                points[0].Y = p.Y;
                points[1].Y = p.Y;
            }
            else if (startP.Y == endP.Y)
            {
                points[0].X = p.X;
                points[1].X = p.X;
                points[0].Y = p.Y - (float)width / 2;
                points[1].Y = p.Y + (float)width / 2;
            }
            else
            { 
                points[0].X = (float)(p.X + ((dy / d) * (double)width / 2.0));
                points[0].Y = (float)(p.Y - ((dx / d) * (double)width / 2.0));
                points[1].X = (float)(p.X - ((dy / d) * (double)width / 2.0));
                points[1].Y = (float)(p.Y + ((dx / d) * (double)width / 2.0));
            }
            return points;
        }



        // 長方形の辺からの長さでなんとかなる？
        // 辺からの長さでの判定はやめる。外積２種類で。
        private bool isInclude(int x, int y, PointF[] startpoints, PointF[] endpoints)
        {
            bool result = false;


            //if (isInclude(x, y, startpoints[0], startpoints[1], endpoints[0]))
            if (isInclude(x, y, startpoints[0], startpoints[1], endpoints[0]) && 
                isInclude(x,y, endpoints[1], startpoints[1], endpoints[0]))
            {
                result = true;
            }

            return result;
        }

        // 長方形を想定。
        // 外積を用いる。
        private bool isInclude(int x, int y, PointF o, PointF p1, PointF p2)
        {
            bool result = false;

            PointF vec = new PointF(x - o.X, y - o.Y);
            PointF vecP1 = new PointF(p1.X - o.X, p1.Y - o.Y);
            PointF vecP2 = new PointF(p2.X - o.X, p2.Y - o.Y);
            double L0 = Math.Sqrt((double)vec.X * (double)vec.X + (double)vec.Y * (double)vec.Y);
            double L1 = Math.Sqrt((double)vecP1.X * (double)vecP1.X + (double)vecP1.Y * (double)vecP1.Y);
            double L2 = Math.Sqrt((double)vecP2.X * (double)vecP2.X + (double)vecP2.Y * (double)vecP2.Y);

            if (L1 == 0.0 && L2 == 0.0)
            {
                result = false;
            }
            else if (L1 == 0.0)
            {
                result = false;
            }
            else if (L2 == 0.0)
            {
                result = false;
            }
            else
            {
                //double l1 = Math.Abs((double)crosPs(vec, vecP1) / L1);
                //double l2 = Math.Abs((double)crosPs(vec, vecP2) / L2);
                //if (l1 <= L2 && l2 <= L1)
                //{
                    if (crosPs(vecP1, vecP2) >= 0 && crosPs(vecP1, vec) >= 0 && crosPs(vec, vecP2) >= 0)
                    {
                        result = true;
                    }
                    else if (crosPs(vecP1, vecP2) <= 0 && crosPs(vecP1, vec) <= 0 && crosPs(vec, vecP2) <= 0)
                    {
                        result = true;
                    }

                //}
            }

            return result;
        }






        // ///////////////////////////////////////////////////////////////////////////////////

        // 一辺widthの正方形の中心をstartPに置き、endPまで中心を動かしていくような描画。
        // 正方形の辺はLayerのx軸に平行または直行。
        private Rectangle DrawLine_FIX_SQUARE_FILL(int a, int[] colors, Point startP, Point endP, int width, bool IsPENMODE_LINE)
        {
            Point start = new Point(startP.X - width / 2, startP.Y - width / 2);
            Point end = new Point(endP.X - width / 2, endP.Y - width / 2);

            int largeX = Math.Max(start.X, end.X);
            int smallX = Math.Min(start.X, end.X);
            int largeY = Math.Max(start.Y, end.Y);
            int smallY = Math.Min(start.Y, end.Y);
            
            int step = (width - 1) / 2;
            if (step == 0) step = 1;
            if (IsPENMODE_LINE)
            {
                step = 1;
            }

            // 使いそうなところをfalseに
            for (int x = smallX; x < largeX + width; x++)
            {
                for (int y = smallY; y < largeY + width; y++)
                {
                    setDotIsWrittenFalse(x, y);
                }
            }


            if (largeX - smallX > largeY - smallY)
            {
                Point s = start;
                Point e = end;
                if (start.X > end.X) {  s = end; e = start; }
                for (int x = s.X; x < e.X; x += step)
                {
                    int tmpx = x;
                    int tmpy = (int) ( s.Y + (e.Y - s.Y) * (double)(x - s.X) / (double)(e.X - s.X) );
                    for (int i = 0; i < width; i++)
                    {
                        for (int j = 0; j < width; j++)
                        {
                            if (DotIsWritten(tmpx + i, tmpy + j))
                                continue;
                            switch (dotdrawmode)
                            {
                                case DotDrawMode.OVERWRITE:
                                        dotOverWrite(tmpx + i, tmpy + j, a, colors);
                                        setDotIsWrittenTrue(tmpx + i, tmpy + j);
                                    break;
                                case DotDrawMode.SIMPLEMIX:
                                        dotSimpleMix(tmpx + i, tmpy + j, a, colors);
                                        setDotIsWrittenTrue(tmpx + i, tmpy + j);
                                    break;
                                default: break;
                            }
                        }

                    }
                }
            }
            else
            {
                Point s = start;
                Point e = end;
                if (start.Y > end.Y) { s = end; e = start; }
                for (int y = s.Y; y < e.Y; y += step)
                {
                    int tmpy = y;
                    int tmpx = (int)(s.X + (e.X - s.X) * (double)(y - s.Y) / (double)(e.Y - s.Y));
                    for (int i = 0; i < width; i++)
                    {
                        for (int j = 0; j < width; j++)
                        {
                            switch (dotdrawmode)
                            {
                                case DotDrawMode.OVERWRITE:
                                    if (!DotIsWritten(tmpx + i, tmpy + j))
                                    {
                                        dotOverWrite(tmpx + i, tmpy + j, a, colors);
                                        setDotIsWrittenTrue(tmpx + i, tmpy + j);
                                    }
                                    break;
                                case DotDrawMode.SIMPLEMIX:
                                    if (!DotIsWritten(tmpx + i, tmpy + j))
                                    {
                                        dotSimpleMix(tmpx + i, tmpy + j, a, colors);
                                        setDotIsWrittenTrue(tmpx + i, tmpy + j);
                                    }
                                    break;
                                default: break;
                            }
                        }

                    }
                }
            }
            // 
            Rectangle rect = new Rectangle(smallX, smallY, largeX - smallX + 1 + width, largeY - smallY + 1 + width);
            return rect;
        }







        // //////////////////////////////////////////////////////////////////////

        //
        private Rectangle DrawLine_UNFIX_RECTANGLE_FILL(int a, int[] colors, Point startP, Point endP, int width, bool IsPENMODE_LINE)
        {
            Rectangle rect = DrawLine_UNFIX_RECTANGLE_FILL_AND_CIRCLE_FILL(a,colors,startP,endP,width,IsPENMODE_LINE, DrawLinePenKind.UNFIX_RECTANGLE_FILL);
            return rect;
        }

        // 直径widthの円の中心をstartPに置き、endPまで中心を動かしていくような描画。
        private Rectangle DrawLine_CIRCLE_FILL(int a, int[] colors, Point startP, Point endP, int width, bool IsPENMODE_LINE)
        {
            // 忘れるな
            // switch (dotdrawmode)

            Rectangle rect = DrawLine_UNFIX_RECTANGLE_FILL_AND_CIRCLE_FILL(a,colors,startP,endP,width,IsPENMODE_LINE, DrawLinePenKind.CIRCLE_FILL);
            return rect;

        }

        // //////////////
        private Rectangle DrawLine_DrawLine_CIRCLE_RANDOM_DOT(int a, int[] colors, Point startP, Point endP, int width, bool IsPENMODE_LINE, DrawLinePenKind dlpk)
        {
                        // 忘れるな
            // switch (dotdrawmode)

            double dx = (double)(endP.X - startP.X);
            double dy = (double)(endP.Y - startP.Y);
            double d = Math.Sqrt(dx * dx + dy * dy);

            if (dx == 0 && dy == 0)
            {
                Rectangle rect = new Rectangle(0, 0, 0, 0);
                return rect;
            }

            PointF[] startmagicpoints = getMagicPoints(startP, startP, endP, width);
            PointF endPF = new PointF(endP.X, endP.Y);
            endPF.X += (float)((double)width * dx / d / 5.0);
            endPF.Y += (float)((double)width * dy / d / 5.0);
            PointF[] endmagicpoints = getMagicPoints(endPF, startP, endP, width);

            int smallX = (int)Math.Min(startmagicpoints[0].X, Math.Min(startmagicpoints[1].X, Math.Min(endmagicpoints[0].X, endmagicpoints[1].X))) - width / 2;
            int largeX = (int)Math.Max(startmagicpoints[0].X, Math.Max(startmagicpoints[1].X, Math.Max(endmagicpoints[0].X, endmagicpoints[1].X))) + width / 2;
            int smallY = (int)Math.Min(startmagicpoints[0].Y, Math.Min(startmagicpoints[1].Y, Math.Min(endmagicpoints[0].Y, endmagicpoints[1].Y))) - width / 2;
            int largeY = (int)Math.Max(startmagicpoints[0].Y, Math.Max(startmagicpoints[1].Y, Math.Max(endmagicpoints[0].Y, endmagicpoints[1].Y))) + width / 2;

            // 使いそうなところをfalseに
            for (int x = smallX; x <= largeX; x++)
            {
                for (int y = smallY; y <= largeY; y++)
                {
                    setDotIsWrittenFalse(x, y);
                }
            }

            for (int x = smallX; x <= largeX; x++)
            {
                for (int y = smallY; y <= largeY; y++)
                {
                    if (DotIsWritten(x, y))
                        continue;

                    bool include = false;
                    include = isInclude(x, y, startmagicpoints, endmagicpoints) ||       
                        (x - startmagicpoints[0].X) * (x - startmagicpoints[0].X) + (y - startmagicpoints[0].Y) * (y - startmagicpoints[0].Y) + (x - startmagicpoints[1].X) * (x - startmagicpoints[1].X) + (y - startmagicpoints[1].Y) * (y - startmagicpoints[1].Y) <= width * width ||     
                        (x - endmagicpoints[0].X) * (x - endmagicpoints[0].X) + (y - endmagicpoints[0].Y) * (y - endmagicpoints[0].Y) + (x - endmagicpoints[1].X) * (x - endmagicpoints[1].X) + (y - endmagicpoints[1].Y) * (y - endmagicpoints[1].Y) <= width * width;

                    int num = 100;
                    switch (dlpk)
                    {
                        case DrawLinePenKind.CIRCLE_RANDOM_DOT_CONC:
                            num = 15;
                            break;
                        case DrawLinePenKind.CIRCLE_RANDOM_DOT_MID:
                            num = 100;
                            break;
                        case DrawLinePenKind.CIRCLE_RANDOM_DOT_SPARSE:
                            num = 500;
                            break;
                        default:
                            break;
                    }
                    
                    if ( random.Next(num) > 0)
                        include = false;
                    if (include)
                    {
                        switch (dotdrawmode)
                        {
                            case DotDrawMode.OVERWRITE:
                                dotOverWrite(x, y, a, colors);
                                setDotIsWrittenTrue(x, y);
                                break;
                            case DotDrawMode.SIMPLEMIX:
                                if (!DotIsWritten(x, y))
                                    dotSimpleMix(x, y, a, colors);
                                setDotIsWrittenTrue(x, y);
                                break;
                            default: break;
                        }
                    }  
                }  
            }

            Rectangle rect2 = new Rectangle(smallX, smallY, largeX - smallX + 1, largeY - smallY + 1);
            return rect2;
        }



        // ///////////////////////////////////////////////////////////////////////

        public Rectangle FillRectangle(int a, int[] colors, Rectangle rect)
        {
            int startx = rect.Left; if (startx < 0) startx = 0;
            int starty = rect.Top; if (starty < 0) starty = 0;
            int endx = rect.Right;if (endx >Width) endx = Width;
            int endy = rect.Bottom; if (endy > Height) endy = Height;
            for (int x = startx; x < endx; x++)
            {
                for (int y = starty; y < endy; y++)
                {
                    //SetDot(x, y, a, colors);
                    switch (dotdrawmode)
                    {
                        case DotDrawMode.OVERWRITE: dotOverWrite(x, y, a, colors); break;
                        case DotDrawMode.SIMPLEMIX: dotSimpleMix(x, y, a, colors); break;
                        default: break;
                    }
                }
            }
            //
            Rectangle tmp = new Rectangle(startx, starty, endx - startx, endy - starty);
            return tmp;
        }



        // /////////////////////////////////////////

        public Rectangle DrawEllipse(int a, int[] colors, Point start, Point end, int width, DrawLinePenKind dlpk)
        {
            int largeX = Math.Max(start.X, end.X);
            int smallX = Math.Min(start.X, end.X);
            int largeY = Math.Max(start.Y, end.Y);
            int smallY = Math.Min(start.Y, end.Y);

            //// 使いそうなところをfalseに
            //for (int x = smallX - width; x < largeX + width; x++)
            //{
            //    for (int y = smallY - width; y < largeY + width; y++)
            //    {
            //        setDotIsWrittenFalse(x, y);
            //    }
            //}

            Point e_o = new Point((largeX + smallX) / 2, (largeY + smallY) / 2);
            int e_a = (largeX - smallX) / 2;
            int e_b = (largeY - smallY) / 2;
            if (e_a == 0 || e_b == 0)
            {
                Rectangle rect = new Rectangle(0,0,1,1); // dummy
                return rect;
            }
            int a2 = e_a * e_a;
            int b2 = e_b * e_b;

            int compromise = -1;

            if (largeX - smallX > largeY - smallY)
            {
                for (int x = smallX - width / 2; x < largeX + width / 2; x++)
                {
                    int tmpx = x;
                    int tmpy = (int)(e_b * Math.Sqrt(1 - (double)(tmpx - e_o.X) * (tmpx - e_o.X) / a2));
                    int tmpy1 = e_o.Y + tmpy;
                    int tmpy2 = e_o.Y - tmpy;

                    int tmpxx = x + 1;
                    int tmpyy = (int)(e_b * Math.Sqrt(1 - (double)(tmpxx - e_o.X) * (tmpxx - e_o.X) / a2));
                    int tmpyy1 = e_o.Y + tmpyy;
                    int tmpyy2 = e_o.Y - tmpyy;

                    if (tmpyy - tmpy > compromise || tmpy - tmpyy > compromise)
                    {
                        DrawLine(a, colors, new Point(tmpx, tmpy1), new Point(tmpxx, tmpyy1), width, false, dlpk);
                        DrawLine(a, colors, new Point(tmpx, tmpy2), new Point(tmpxx, tmpyy2), width, false, dlpk);
                    }
                    else
                    {
                        //for (int i = 0; i < width; i++)
                        //{
                        //    for (int j = 0; j < width; j++)
                        //    {
                        //        switch (dotdrawmode)
                        //        {
                        //            case DotDrawMode.OVERWRITE:
                        //                //if (!DotIsWritten(tmpx + i, tmpy1 + j))
                        //                    dotOverWrite(tmpx + i, tmpy1 + j, a, colors);
                        //                //if (!DotIsWritten(tmpx + i, tmpy2 + j))
                        //                    dotOverWrite(tmpx + i, tmpy2 + j, a, colors);
                        //                break;
                        //            case DotDrawMode.SIMPLEMIX:
                        //                //if (!DotIsWritten(tmpx + i, tmpy1 + j))
                        //                    dotSimpleMix(tmpx + i, tmpy1 + j, a, colors);
                        //                //if (!DotIsWritten(tmpx + i, tmpy2 + j))
                        //                    dotSimpleMix(tmpx + i, tmpy2 + j, a, colors);
                        //                break;
                        //            default: break;
                        //        }
                        //    }
                        //}
                    }
                }
            }
            else
            {
                for (int y = smallY; y < largeY; y ++)
                {
                    int tmpy = y;
                    int tmpx = (int)(e_a * Math.Sqrt(1 - (double)(tmpy - e_o.Y) * (tmpy - e_o.Y) / b2));
                    int tmpx1 = e_o.X + tmpx;
                    int tmpx2 = e_o.X - tmpx;

                    int tmpyy = y + 1;
                    int tmpxx = (int)(e_a * Math.Sqrt(1 - (double)(tmpyy - e_o.Y) * (tmpyy - e_o.Y) / b2));
                    int tmpxx1 = e_o.X + tmpxx;
                    int tmpxx2 = e_o.X - tmpxx;

                    if (tmpxx - tmpx > compromise || tmpx - tmpxx  > compromise)
                    {
                        DrawLine(a, colors, new Point(tmpx1, tmpy), new Point(tmpxx1, tmpyy), width, false, dlpk);
                        DrawLine(a, colors, new Point(tmpx2, tmpy), new Point(tmpxx2, tmpyy), width, false, dlpk);
                    }
                    else
                    {
                        //for (int i = 0; i < width; i++)
                        //{
                        //    for (int j = 0; j < width; j++)
                        //    {
                        //        switch (dotdrawmode)
                        //        {
                        //            case DotDrawMode.OVERWRITE:
                        //                if (!DotIsWritten(tmpx1 + i, tmpy + j))
                        //                    dotOverWrite(tmpx1 + i, tmpy + j, a, colors);
                        //                if (!DotIsWritten(tmpx2 + i, tmpy +j))
                        //                    dotOverWrite(tmpx2 + i, tmpy + j, a, colors);
                        //                break;
                        //            case DotDrawMode.SIMPLEMIX:
                        //                if (!DotIsWritten(tmpx1 + i, tmpy + j))
                        //                    dotSimpleMix(tmpx1 + i, tmpy + j, a, colors);
                        //                if (!DotIsWritten(tmpx2 + i, tmpy +j ))
                        //                    dotSimpleMix(tmpx2 + i, tmpy + j, a, colors);
                        //                break;
                        //            default: break;
                        //        }
                        //    }
                        //}
                    }
                }
            }

            Rectangle tmp = new Rectangle(smallX - width / 2, smallY - width / 2, largeX - smallX + 1 + width, largeY - smallY + 1 + width);
            return tmp;
        }


        //  //////////////
        public Rectangle StampDDC(int a, int[] colors, Point p)
        {
            // 忘れるな
            // switch (dotdrawmode)
            int width = dotDrawCycle.getSizeDotDrawCycle().Width;
            int height = dotDrawCycle.getSizeDotDrawCycle().Height;
            int startx = p.X - width / 2;
            int starty = p.Y - height / 2;

            // 記憶しておく。あとでもどす。
            DotDrawCycle.DotDrawCycleMode ddcddcm = dotDrawCycle.GetDotDrawCycleMode();
            dotDrawCycle.SetDotDrawCycleMode(DotDrawCycle.DotDrawCycleMode.STAMP);

            for (int x = 0; x < width; x++)
            {
                for (int y = 0; y < height; y++)
                {
                    if (dotDrawCycle.getDrawOrNotDotDrawCycle(x,y))
                    {
                        switch (dotdrawmode)
                        {
                            case DotDrawMode.OVERWRITE: dotOverWrite(startx + x, starty + y, a, colors); break;
                            case DotDrawMode.SIMPLEMIX: dotSimpleMix(startx + x, starty + y, a, colors); break;
                            default: break;
                        }
                    }
                }
            }

            // もどす。
            dotDrawCycle.SetDotDrawCycleMode(ddcddcm);

            Rectangle rect = new Rectangle(startx, starty, width, height);
            if (this.antiAliasing)
            {
                AntiAliasing(rect);
            }
            return rect;
        }

        // //////////////////////////////////////////////////////

        public void ForUserPenKind(int a, int[] colors, Rectangle rect, bool[,] onOff)
        {
            if (onOff.GetLength(0) != rect.Width || onOff.GetLength(1) != rect.Height)
            {
                throw new Exception("rectとonOffのサイズが異なります。");
            }

            for (int x = rect.X; x < rect.X + rect.Width - 1; x++)
            {
                for (int y = rect.Y; y < rect.Y + rect.Height - 1; y++)
                {
                    switch (dotdrawmode)
                    {
                        case DotDrawMode.OVERWRITE:
                            if (onOff[x - rect.X, y - rect.Y])
                            {
                                dotOverWrite(x, y, a, colors);
                            }
                            break;
                        case DotDrawMode.SIMPLEMIX:
                            if (onOff[x - rect.X, y - rect.Y])
                            {
                                dotSimpleMix(x, y, a, colors);
                            }
                            break;
                        default: break;
                    }
                }
            }

            if (this.antiAliasing)
            {
                AntiAliasing(rect);
            }
        }

        public Point[,] UserPenKindDrawEllipse(Point start, Point end, int penSize)
        {
            //Point[,] points  = new Point[1,2];
            //points[0, 0] = new Point(0, 0);
            //points[0, 1] = new Point(5, 5);
            //return points;

            double a = Math.Abs(start.X - end.X) / 2.0;
            double b = Math.Abs(start.Y - end.Y) / 2.0;
            ArrayList points = new ArrayList();
            int r = 0;
            points.Add(new Point((int)(a * Math.Cos(r)), (int)(b * Math.Sin(r))));
            for (r = 1; r <= 360; r += 5)
            {
                int x = (int)(a * Math.Cos(Math.PI * 2.0 * r / 360.0));
                int y = (int)(b * Math.Sin(Math.PI * 2.0 * r / 360.0));
                if (x != ((Point)points[points.Count - 1]).X || y != ((Point)points[points.Count - 1]).Y)
                {
                    points.Add(new Point(x, y));
                }
            }


            Point o = new Point((start.X + end.X) / 2, (start.Y + end.Y) / 2);
            Point[,] returnPoints;
            if (points.Count == 1)
            {
                returnPoints = new Point[1, 2];
                returnPoints[0, 0] = returnPoints[0, 1] = new Point(o.X + ((Point)points[0]).X, o.Y + (((Point)points[0]).Y));
            }
            else
            {
                returnPoints = new Point[points.Count, 2];
                for (int i = 0; i < points.Count; i++)
                {
                    int indexs = i % points.Count;
                    int indexe = (i + 1) % points.Count;
                    returnPoints[i, 0] = new Point(o.X + ((Point)points[indexs]).X, o.Y + (((Point)points[indexs]).Y));
                    returnPoints[i, 1] = new Point(o.X + ((Point)points[indexe]).X, o.Y + (((Point)points[indexe]).Y));
                }
            }
            return returnPoints;

        }

        public void Resize(int newWidht, int newHeight)
        {
            int[,] new_alpha = new int[newWidht,newHeight];
            int[,] new_red = new int[newWidht,newHeight];
            int[,] new_green = new int[newWidht,newHeight];
            int[,] new_blue = new int[newWidht,newHeight];
            bool[,] new_dotIsWritten = new bool[newWidht, newHeight];

            for (int x = 0; x < newWidht; x++)
            {
                for (int y = 0; y < newHeight; y++)
                {
                    new_alpha[x, y] = 0;
                    new_red[x, y] = transparent[0];
                    new_green[x, y] = transparent[1];
                    new_blue[x, y] = transparent[2];
                }
            }

            //
            for (int x = 0; x < Math.Min(Width, newWidht); x++)
            {
                for (int y = 0; y < Math.Min(Height, newHeight); y++)
                {
                    new_alpha[x, y] = alpha[x, y];
                    new_red[x, y] = red[x, y];
                    new_green[x, y] = green[x, y];
                    new_blue[x, y] = blue[x, y];
                }
            }

            this.alpha = new_alpha;
            this.red = new_red;
            this.green = new_green;
            this.blue = new_blue;
            this.dotIsWritten = new_dotIsWritten;
            this.Width = newWidht;
            this.Height = newHeight;

            this.aa_alpha = new int[this.Width, this.Height];
            this.aa_red = new int[this.Width, this.Height];
            this.aa_green = new int[this.Width, this.Height];
            this.aa_blue = new int[this.Width, this.Height];
        }


        /////////////////////////////////////////////////////////////////////////

        public void setAntiAliasingType(AntiAliasingType aat)
        {
            this.aat = aat;
        }

        public AntiAliasingType getAntiAliasingType()
        {
            return this.aat;
        }

        private void AntiAliasing(Rectangle rect)
        {
            Debug.WriteLine(this.antiAliasing.ToString());


            switch (aat)
            {
                case AntiAliasingType.AAT1:
                    AntiAliasing1(rect);
                    break;
                case AntiAliasingType.AAT2:
                    AntiAliasing1(rect);
                    AntiAliasing1(rect);
                    AntiAliasing1(rect);
                    AntiAliasing1(rect);
                    AntiAliasing1(rect);
                    AntiAliasing1(rect);
                    AntiAliasing1(rect);
                    break;
                default: break;
            }

        }

        /////////////////////////////////////////////////////////////////////////

        private void AntiAliasing1(Rectangle rect)
        {
            Debug.WriteLine(this.antiAliasing.ToString());

            for (int x = rect.Left; x < rect.Right; x++)
            {
                if (x < 0) continue;
                if (x > this.Width - 1) continue;
                for (int y = rect.Top; y < rect.Bottom; y++)
                {
                    if (y < 0) continue;
                    if (y > this.Height - 1) continue;

                    int px = x;
                    int py = y;
                    int plx = x - 1; if (plx < 0) plx = 0;
                    int ply = y;
                    int prx = x + 1; if (prx > this.Width - 1) prx = this.Width - 1;
                    int pry = y;
                    int pux = x;
                    int puy = y - 1; if (puy < 0) puy = 0;
                    int pdx = x;
                    int pdy = y + 1; if (pdy > this.Height - 1) pdy = this.Height - 1;

                    bool need = IsNeedAntialiasing1(px, py, plx, ply, prx, pry, pux, puy, pdx, pdy);
                    CalcAntiAliasing1(px, py, plx, ply, prx, pry, pux, puy, pdx, pdy, need);
                }
            }

            for (int x = rect.Left; x < rect.Right; x++)
            {
                if (x < 0) continue;
                if (x > this.Width - 1) continue;
                for (int y = rect.Top; y < rect.Bottom; y++)
                {
                    if (y < 0) continue;
                    if (y > this.Height - 1) continue;
                    SetAntiAliasing(x, y);
                }
            }
        }

        private bool IsNeedAntialiasing1(int px, int py, int plx, int ply, int prx, int pry,
            int pux, int puy, int pdx, int pdy)
        {
            bool result = true;
            if (!IsMuchDifference1(px, py, plx, ply) && !IsMuchDifference1(px, py, prx, pry) )
            {
                result = false;
            }
            if(!IsMuchDifference1(px, py, pux, puy) && !IsMuchDifference1(px, py, pdx, pdy))
            {
                result = false;
            }
            return result;
        }

        private bool IsMuchDifference1(int px, int py, int x, int y)
        {
            int much_diff = 5;
            bool result = false;
            if (Math.Abs(alpha[px, py] - alpha[x, y]) > much_diff ||
                Math.Abs(red[px, py] - red[x, y]) > much_diff ||
                Math.Abs(green[px, py] - green[x, y]) > much_diff ||
                Math.Abs(blue[px, py] - blue[x, y]) > much_diff)
            {
                result = true;
            }
            return result;
        }


        private void CalcAntiAliasing1(int px, int py, int plx, int ply, int prx, int pry,
            int pux, int puy, int pdx, int pdy, bool need)
        {
            if (need)
            {
                int weight = 5;
                this.aa_alpha[px, py] = (this.alpha[px, py] * weight + this.alpha[plx, ply] + this.alpha[prx, pry] + this.alpha[pux, puy] + this.alpha[pdx, pdy]) / (weight + 4);
                //this.aa_alpha[px, py] = this.alpha[px, py];
                this.aa_red[px, py] = (this.red[px, py] * weight + this.red[plx, ply] + this.red[prx, pry] + this.red[pux, puy] + this.red[pdx, pdy]) / (weight + 4);
                this.aa_green[px, py] = (this.green[px, py] * weight + this.green[plx, ply] + this.green[prx, pry] + this.green[pux, puy] + this.green[pdx, pdy]) / (weight + 4);
                this.aa_blue[px, py] = (this.blue[px, py] * weight + this.blue[plx, ply] + this.blue[prx, pry] + this.blue[pux, puy] + this.blue[pdx, pdy]) / (weight + 4);
            }
            else
            {
                this.aa_alpha[px, py] = this.alpha[px, py];
                this.aa_red[px, py] = this.red[px, py];
                this.aa_green[px, py] = this.green[px, py];
                this.aa_blue[px, py] = this.blue[px, py];
            }
        }

        private void SetAntiAliasing(int px, int py)
        {
            this.alpha[px, py] = this.aa_alpha[px, py];
            this.red[px, py] = this.aa_red[px, py];
            this.green[px, py] = this.aa_green[px, py];
            this.blue[px, py] = this.aa_blue[px, py];
        }



        //////////////////////////////////////////////////////////////////////////
    }
}
