﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.IO;
using System.Reflection;

namespace MyNote001
{
    public partial class MacrosCommand : Form
    {
        MyMacros mym;

        public MacrosCommand(MyMacros mymacros, bool bApng, int apngstep)
        {
            InitializeComponent();
            setMyMacros(mymacros);
            this.checkBoxMakeApng.Checked = bApng;
            this.I_ApngstepChanged(apngstep);
        }

        private void setMyMacros(MyMacros mymacros)
        {
            this.mym = mymacros;
        }

        // MyMacros のイベントに登録する用。
        public void convertChanged(string sa, string sb, string sc, string sd, string se, string sf, string sg, string sh, string sk, string sl, string sm, string sn)
        {
            labelsa.Text = sa;
            labelsb.Text = sb;
            labelsc.Text = sc;
            labelsd.Text = sd;
            labelse.Text = se;
            labelsf.Text = sf;
            labelsg.Text = sg;
            labelsh.Text = sh;
            labelsk.Text = sk;
            labelsl.Text = sl;
            labelsm.Text = sm;
            labelsn.Text = sn;
        }

        // MyMacros のイベントに登録する用。
        public void macrosCommandEnabled(bool b)
        {
            this.Enabled = b;
        }

        private void buttonEvaluate_Click(object sender, EventArgs e)
        {
            string[] lines = richTextBoxCommand.Lines;
            mym.evaluate(lines);
        }

        private void buttonPasteFromClipboard_Click(object sender, EventArgs e)
        {
            richTextBoxCommand.SelectedText = Clipboard.GetText();
        }

        private void MacrosCommand_Load(object sender, EventArgs e)
        {
                        
            string text = "";
            StreamReader sr =null;
            try
            {
                string strAppDir =
Path.GetDirectoryName(Assembly.GetExecutingAssembly().GetModules()[0].FullyQualifiedName);
                //MessageBox.Show(strAppDir);
                string filepath = strAppDir + Path.DirectorySeparatorChar.ToString() + "macros.txt";
                sr = new StreamReader(filepath, Encoding.GetEncoding("Shift_JIS"));
                text = sr.ReadToEnd();
            }
            catch (Exception exc)
            {
                Console.WriteLine(exc.ToString());
            }
            finally
            {
                if(sr != null)
                sr.Close();
            }

            richTextBoxCommand.Text = text;
        }

        private void buttonClear_Click(object sender, EventArgs e)
        {
            richTextBoxCommand.Text = "";
        }

        private void comboBoxMacro_SelectedIndexChanged(object sender, EventArgs e)
        {
            string foldername = "macros";
            string filename = comboBoxMacro.SelectedItem.ToString();

            string text = "";
            StreamReader sr = null;
            try
            {
                string strAppDir =
Path.GetDirectoryName(Assembly.GetExecutingAssembly().GetModules()[0].FullyQualifiedName);
                //MessageBox.Show(strAppDir);
                string filepath = strAppDir + Path.DirectorySeparatorChar.ToString() + foldername + Path.DirectorySeparatorChar.ToString() + filename;
                sr = new StreamReader(filepath, Encoding.GetEncoding("Shift_JIS"));
                text = sr.ReadToEnd();
            }
            catch (Exception exc)
            {
                Console.WriteLine(exc.ToString());
            }
            finally
            {
                if (sr != null)
                    sr.Close();
            }

            richTextBoxCommand.Text = text;
        }

        private void checkBoxMakeApng_CheckedChanged(object sender, EventArgs e)
        {
            mym.setB_MakeApng(checkBoxMakeApng.Checked);
        }

        // MyMacros のイベントに登録する用。
        public void B_MakeApngChanged(bool b)
        {
            this.checkBoxMakeApng.Checked = b;
        }

        private void checkBoxMakeApng_Click(object sender, EventArgs e)
        {
            mym.setB_MakeApng(checkBoxMakeApng.Checked);
        }

        // MyMacros のイベントに登録する用。
        public void I_ApngstepChanged(int step)
        {
            this.labelStep.Text = string.Format("apngstep: {0}", step);
        }
    }
}
