﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;


namespace MyNote001
{
    public partial class MacrosWatchAsCommand : Form
    {
        MyMacros mym;

        bool bool_stringbuilder;
        StringBuilder stringbuilder;

        public const string USE_STRINGBUILDER = "use_stringbuilder";

        public MacrosWatchAsCommand(MyMacros mymacros)
        {
            InitializeComponent();
            bool_stringbuilder = false;
            checkBoxUseStringbuilder.Checked = false;
            stringbuilder = new StringBuilder();
            setMyMacros(mymacros);
        }

        private void setMyMacros(MyMacros mymacros)
        {
            this.mym = mymacros;
        }

        // MyMacros のイベントに登録する用。
        public void watchMyMacros(string str)
        {
            if (str == USE_STRINGBUILDER)
            {
                if (!bool_stringbuilder)
                {
                    this.checkBoxUseStringbuilder.Checked = true;
                    this.checkBoxUseStringbuilder_CheckedChanged(new Object(), new EventArgs());
                }
                return;
            }

            if (bool_stringbuilder)
            {
                stringbuilder.Append(str);
                stringbuilder.Append(Environment.NewLine);
            }
            else
            {
                this.richTextBox1.Text += str;
                this.richTextBox1.Text += Environment.NewLine;
                //this.richTextBox1.Text += string.Format("\r\n");

                if (checkBoxAutoScroll.Checked == true)
                {
                    this.richTextBox1.Select(richTextBox1.Text.Length - 1, 1);
                    this.richTextBox1.ScrollToCaret();
                }
            }
        }

        private void buttonClear_Click(object sender, EventArgs e)
        {
            this.richTextBox1.Text = "";
        }

        private void buttonCopyToClipboard_Click(object sender, EventArgs e)
        {
            try
            {
                Clipboard.SetText(richTextBox1.Text);
            }
            catch (Exception exc)
            {
                MessageBox.Show(exc.ToString());
            }
        }

        private void buttonGetNowStatus_Click(object sender, EventArgs e)
        {
            string str = mym.nowStatus();

            this.richTextBox1.Text += str;
            this.richTextBox1.Text += Environment.NewLine;

            if (checkBoxAutoScroll.Checked == true)
            {
                this.richTextBox1.Select(richTextBox1.Text.Length - 1, 1);
                this.richTextBox1.ScrollToCaret();
            }
        }

        private void methodsub()
        {
            string str = stringbuilder.ToString();

            this.richTextBox1.Text += str;

            int length = stringbuilder.Length;
            stringbuilder.Remove(0, length);
        }


        private void checkBoxUseStringbuilder_CheckedChanged(object sender, EventArgs e)
        {
            bool_stringbuilder = checkBoxUseStringbuilder.Checked;

            if (bool_stringbuilder)
            {
                this.checkBoxAutoScroll.Enabled = false;
                this.buttonClear.Enabled = false;
                this.buttonGetNowStatusAsCommand.Enabled = false;
                this.buttonCopyToClipboard.Enabled = false;
            }
            else
            {
                string str = stringbuilder.ToString();
                richTextBox1.Text += str;
                int length = stringbuilder.Length;
                stringbuilder.Remove(0, length);

                this.checkBoxAutoScroll.Enabled = true;
                this.buttonClear.Enabled = true;
                this.buttonGetNowStatusAsCommand.Enabled = true;
                this.buttonCopyToClipboard.Enabled = true;
            }
        }

    }
}
