﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.IO;
using System.Reflection;

namespace MyNote001
{
    public delegate void ResizeEtcEventDelegate(object sender, System.EventArgs e, int width, int height);

    public partial class ResizeEtc : Form
    {
        public event ResizeEtcEventDelegate ResizeEtcEvent;

        public ResizeEtc(int min, int max)
        {
            InitializeComponent();
            numericUpDownWidth.Minimum = numericUpDownHeight.Minimum = min;
            numericUpDownWidth.Maximum = numericUpDownHeight.Maximum = max;
        }

        private void buttonAccept_Click(object sender, EventArgs e)
        {
            // Safely invoke an event:
            ResizeEtcEventDelegate temp = ResizeEtcEvent;

            if (temp != null)
            {
                int width = (int)numericUpDownWidth.Value;
                int height = (int)numericUpDownHeight.Value;
                temp(this, e, width, height);
            }
        }

        private void numericUpDownHeight_ValueChanged(object sender, EventArgs e)
        {

        }

        private void ResizeEtc_Load(object sender, EventArgs e)
        {
            string text = "";
            StreamReader sr =null;
            try
            {
                string strAppDir =
Path.GetDirectoryName(Assembly.GetExecutingAssembly().GetModules()[0].FullyQualifiedName);
                //MessageBox.Show(strAppDir);
                string filepath = strAppDir + Path.DirectorySeparatorChar.ToString() + "resize.txt";
                sr = new StreamReader(filepath, Encoding.GetEncoding("Shift_JIS"));
                text = sr.ReadToEnd();
            }
            catch (Exception exc)
            {
                Console.WriteLine(exc.ToString());
            }
            finally
            {
                if(sr != null)
                sr.Close();
            }

            setComboBoxSize(text);
        }

        private void setComboBoxSize(string text)
        {
            RichTextBox rtb = new RichTextBox();
            rtb.Text = text;
            String[] lines = rtb.Lines;
            comboBoxSize.Items.Clear();
            foreach (string line in lines)
            {
                comboBoxSize.Items.Add(line);
            }
        }

        private void comboBoxSize_SelectedIndexChanged(object sender, EventArgs e)
        {
            string str = comboBoxSize.Text;
            string[] strs = str.Split(new char[] { ',' });
            int[] ints;
            try
            {
                ints = parseStrings(strs);
            }
            catch (Exception exc)
            {
                MessageBox.Show(exc.ToString(), "");
                return;
            }

            // ints 成功
            try
            {
                numericUpDownWidth.Value = ints[0];
                numericUpDownHeight.Value = ints[1];
            }
            catch (Exception exc)
            {
                MessageBox.Show(exc.ToString());
            }
        }

        private int[] parseStrings(string[] strs)
        {
            int[] ints = new int[2];
            if (strs.Length < 2)
            {
                throw new Exception("need 2");
            }

            try
            {
                ints[0] = int.Parse(strs[0]);
            }
            catch (Exception e)
            {
                throw e;
            }

            try
            {
                ints[1] = int.Parse(strs[1]);
            }
            catch (Exception e)
            {
                throw e;
            }

            return ints;
        }
    }
}
