﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Drawing;

namespace MynUserPenKind
{
    public class UserPenKind
    {

        public static object[] method1(Point startp, Point endp, int pensize, int counter)
        {
            int startx = Math.Min(startp.X, endp.X);
            int starty = Math.Min(startp.Y, endp.Y);
            int width = Math.Abs(startp.X - endp.X) + pensize;
            int height = Math.Abs(startp.Y - endp.Y) + pensize;

            int ox = (startp.X + endp.X + pensize) / 2;
            int oy = (startp.Y + endp.Y + pensize) / 2;

            double d = Math.Sqrt(width * width + height * height);
            PointF magic1 = new PointF(ox + (float)((endp.Y - oy) * pensize / d), oy + (float)((startp.X - ox) * pensize / d));
            PointF magic2 = new PointF(ox + (float)((startp.Y - oy) * pensize / d), oy + (float)((endp.X - ox) * pensize / d));
            PointF magicstart = new PointF(startp.X, startp.Y);
            PointF magicend = new PointF(endp.X, endp.Y);

            Rectangle rect = new Rectangle(startx, starty, width, height);
            bool[,] onOff = new bool[width, height];
            for (int x = 0; x < width; x++)
            {
                for (int y = 0; y < height; y++)
                {
                    PointF nowpoint = new PointF(startx + x, starty + y);
                    if (isInclude(nowpoint, magicstart, magicend, magic1, magic2))
                    {
                        onOff[x, y] = true;
                    }
                }
            }
            return new object[] { rect, onOff };
        }

        private static bool isInclude(PointF target, PointF magicstart, PointF magicend, PointF magic1, PointF magic2)
        {
            bool result = false;

            PointF sv0 = new PointF(target.X - magicstart.X, target.Y - magicstart.Y);
            PointF sv1 = new PointF(magic1.X - magicstart.X, magic1.Y - magicstart.Y);
            PointF sv2 = new PointF(magic2.X - magicstart.X, magic2.Y - magicstart.Y);

            PointF ev0 = new PointF(target.X - magicend.X, target.Y - magicend.Y);
            PointF ev1 = new PointF(magic1.X - magicend.X, magic1.Y - magicend.Y);
            PointF ev2 = new PointF(magic2.X - magicend.X, magic2.Y - magicend.Y);

            if (crosPs(sv2, sv1) <= 0 && crosPs(sv2, sv0) <= 0 && crosPs(sv0, sv1) <= 0 ||
                crosPs(sv2, sv1) >= 0 && crosPs(sv2, sv0) >= 0 && crosPs(sv0, sv1) >= 0)
            {
                if (crosPs(ev2, ev1) <= 0 && crosPs(ev2, ev0) <= 0 && crosPs(ev0, ev1) <= 0 ||
                    crosPs(ev2, ev1) >= 0 && crosPs(ev2, ev0) >= 0 && crosPs(ev0, ev1) >= 0)
                {
                    result = true;
                }
            }


            return result;
        }

        private static float crosPs(PointF p1, PointF p2)
        {
            return p1.X * p2.Y - p2.X * p1.Y;
        }

        //
        public static object[] method2(Point startp, Point endp, int pensize, int counter)
        {
            int ox = (startp.X + endp.X)  / 2;
            int oy = (startp.Y + endp.Y)  / 2;
            int width;
            int height;
            if (Math.Abs(startp.X - endp.X) < Math.Abs(startp.Y - endp.Y))
            {
                width = counter % pensize + 2;
                height = (pensize - counter % pensize + 2) / 2;
            }
            else
            {
                width = (pensize - counter % pensize + 2) / 2;
                height = counter % pensize + 2;
            }
            Rectangle rect = new Rectangle(ox - width / 2, oy - height / 2, width, height);
            bool[,] onOff = new bool[width, height];
            for (int x = 0; x < width; x++)
            {
                for (int y = 0; y < height; y++)
                {
                    onOff[x, y] = true;
                }
            }
            return new object[] { rect, onOff };
        }
    }
}
