﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Collections;

namespace MyNote001
{
    public delegate void EddmEventDelegate(object sender, DotDrawCycle ddc, string layer);

    

    public partial class EditDotDrawCycle : Form
    {
        public event EddmEventDelegate EddmEvent;

        DotDrawCycle ddc;

        // const だと変数名が heart_16_8 は使えない。
        // const だとこの代入はおこられる。
        // readonlyは実行時定数
        // constはコンパイル時定数
        readonly string heart_16_8 = "0000010000010000" + Environment.NewLine
            + "0001101000101100" + Environment.NewLine
            + "0011000101000110" + Environment.NewLine
            + "0011000010000110" + Environment.NewLine
            + "0001100000001100" + Environment.NewLine
            + "0000110000011000" + Environment.NewLine
            + "0000001101100000" + Environment.NewLine
            + "0000000010000000" + Environment.NewLine;


        public EditDotDrawCycle()
        {
            InitializeComponent();
            comboBoxLayer.SelectedIndex = 0;
            comboBoxDotDrawCycleMode.SelectedIndex = 0;
            ddc = new DotDrawCycle();
            comboBoxPreSet.SelectedIndex = 0;
        }


        private void buttonSet_Click(object sender, EventArgs e)
        {

            string str = comboBoxLayer.SelectedItem.ToString();

            try
            {
                parseAndSetDdc();
            }
            catch (Exception exc)
            {
                MessageBox.Show(exc.ToString(), "fale");
                return;
            }

            // Safely invoke an event:
            EddmEventDelegate temp = EddmEvent;

            if (temp != null)
            {
                temp(this, ddc, str);
            }
        }

        private void parseAndSetDdc()
        {
            string[] lines = textBoxDotDrawCycle.Lines;
            ArrayList lines2 = new ArrayList();
            int w = int.MaxValue;
            foreach(string line  in lines)
            {
                int tmp = countOf0or1(line);
                if (tmp > 0)
                {
                    string tmpline = string0or1(line);
                    w = Math.Min(w, tmp);
                    lines2.Add(tmpline);
                }
            }

            int h = lines2.Count;

            if (w <= 0 || h <= 0)
            {
                throw new Exception("fale");
            }

            labelResultSize.Text = String.Format("{0}, {1}", w, h);
            bool[,] bools = new bool[w, h];
            for (int y = 0; y < h; y++)
            {
                string line = (string)lines2[y];
                for (int x = 0; x < w; x++)
                {
                    char t = line[x];
                    bools[x,y] = (t == '1') ? true : false;
                }
            }
            ddc.SetDotDrawCycle(bools, w, h);

            if (comboBoxDotDrawCycleMode.SelectedItem.ToString() == "DotDrawCycleMode.LAYER")
            {
                ddc.SetDotDrawCycleMode(DotDrawCycle.DotDrawCycleMode.LAYER);
            }
            else if (comboBoxDotDrawCycleMode.SelectedItem.ToString() == "DotDrawCycleMode.CYCLE")
            {
                ddc.SetDotDrawCycleMode(DotDrawCycle.DotDrawCycleMode.CYCLE);
            }
            else if (comboBoxDotDrawCycleMode.SelectedItem.ToString() == "DotDrawCycleMode.CYCLE2")
            {
                ddc.SetDotDrawCycleMode(DotDrawCycle.DotDrawCycleMode.CYCLE2);
            }
        }

        private int countOf0or1(string str)
        {
            int result = 0;
            for (int i = 0; i < str.Length; i++)
            {
                if (str[i] == '0' || str[i] == '1')
                {
                    result++;
                }
            }
            return result;
        }

        private string string0or1(string str)
        {
            string result = "";
            for (int i = 0; i < str.Length; i++)
            {
                if (str[i] == '0' || str[i] == '1')
                {
                    result = result + str[i].ToString();
                }
            }
            return result;
        }

        private void comboBoxPreSet_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (comboBoxPreSet.SelectedItem.ToString() == "heart_16_8")
            {
                textBoxDotDrawCycle.Text = heart_16_8;
            }
            else if (comboBoxPreSet.SelectedItem.ToString() == "1_1")
            {
                textBoxDotDrawCycle.Text = "1";
            }
            else if (comboBoxPreSet.SelectedItem.ToString() == "2_2")
            {
                textBoxDotDrawCycle.Text = "11" + Environment.NewLine + "11";
            }
            else if (comboBoxPreSet.SelectedItem.ToString() == "3_3")
            {
                textBoxDotDrawCycle.Text = "111" + Environment.NewLine + "111" + Environment.NewLine + "111";
            }
            else if (comboBoxPreSet.SelectedItem.ToString() == "4_4")
            {
                textBoxDotDrawCycle.Text = "1111" + Environment.NewLine + "1111" + Environment.NewLine + "1111" + Environment.NewLine + "1111";
            }
            else if (comboBoxPreSet.SelectedItem.ToString() == "8_8")
            {
                textBoxDotDrawCycle.Text = "11111111" + Environment.NewLine 
                    + "11111111" + Environment.NewLine 
                    + "11111111" + Environment.NewLine
                    + "11111111" + Environment.NewLine
                    + "11111111" + Environment.NewLine
                    + "11111111" + Environment.NewLine
                    + "11111111" + Environment.NewLine 
                    + "11111111";
            }
        }

        private void buttonW2x_Click(object sender, EventArgs e)
        {
            txtBoxExpand(textBoxDotDrawCycle, 2, 1);
        }

        private void buttonW3x_Click(object sender, EventArgs e)
        {
            txtBoxExpand(textBoxDotDrawCycle, 3, 1);
        }

        private void buttonW5x_Click(object sender, EventArgs e)
        {
            txtBoxExpand(textBoxDotDrawCycle, 5, 1);
        }

        private void buttonH2x_Click(object sender, EventArgs e)
        {
            txtBoxExpand(textBoxDotDrawCycle, 1, 2);
        }

        private void buttonH3x_Click(object sender, EventArgs e)
        {
            txtBoxExpand(textBoxDotDrawCycle, 1, 3);
        }

        private void buttonH5x_Click(object sender, EventArgs e)
        {
            txtBoxExpand(textBoxDotDrawCycle, 1, 5);
        }

        private void txtBoxExpand(TextBox tb, int wTimes, int hTimes)
        {
            RichTextBox rtb = new RichTextBox();
            rtb.Text = tb.Text;

            string[] lines = rtb.Lines;
            string[] lines2 = new string[lines.Length];
            for (int i = 0; i < lines.Length; i++)
            {
                for (int j = 0; j < lines[i].Length; j++)
                {
                    lines2[i] += new string(lines[i][j], wTimes);
                }
            }
            rtb.Lines = lines2;

            string[] lines3 = rtb.Lines;
            string[] lines4 = new string[lines3.Length * hTimes];
            for (int k = 0; k < lines3.Length; k++)
            {
                for (int l = 0; l < hTimes; l++)
                {
                    lines4[k * hTimes + l] = lines3[k];
                }
            }
            rtb.Lines = lines4;


            try
            {
                tb.Text = rtb.Text;
            }
            catch (Exception e)
            {
                MessageBox.Show(e.ToString());
            }
        }

    }
}
